/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * callbacks.c
 * Copyright (C) ubuntu 2012 <ubuntu@>
 * 
 * diamondring is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * diamondring is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <math.h>
#include "callbacks.h"


void
destroy (GtkWidget *widget, gpointer data)
{
	gtk_main_quit ();
}


void drawDiamondRing(GtkWidget *widget, GdkGC *gc, int cx, int cy, int r, int n)
{
	int x1, y1, x2, y2;
	int i, j;
	double rad = M_PI * (double)2.0 / (double)n;
	for(i = 0; i < n - 1; i++) {
		x1 = (int)((double)cx + (double)r * cos(rad * (double)i) + (double)0.5);
		y1 = (int)((double)cy + (double)r * sin(rad * (double)i) + (double)0.5);
		for(j = i + 1; j < n; j++) {
			x2 = (int)((double)cx + (double)r * cos(rad * (double)j) + (double)0.5);
			y2 = (int)((double)cy + (double)r * sin(rad * (double)j) + (double)0.5);
			gdk_draw_line(widget->window, gc, x1, y1, x2, y2);
		}
	}
}

gboolean on_drawingarea_expose_event(GtkWidget *widget,
	GdkEventExpose *event,
	gpointer user_data)
{
	gint width = widget->allocation.width;
	gint height = widget->allocation.height;
	
	GdkGC *gc = widget->style->black_gc;
	
	drawDiamondRing(widget, gc, (width / 2), (height/2), 120, 16);
	
	return FALSE;	
}